
//	Copyright 2010 PaletteSoft LLC

//	******  ******* *     * *******  *****  *******                           
//	*     * *       *     *    *    *     * *                                 
//	*     * *       *     *    *    *       *                                 
//	*     * ******* *     *    *    *       *******                           
//	*     * *        *   *     *    *       *                                 
//	*     * *         * *      *    *     * *                                 
//	******  *******    *    *******  *****  *******                           

// ===========================================================================
// =	CL^															 =
// ===========================================================================
//	008 2010.11.24				00.23
//	EPSW_5(RA3)̒ǉ
// ---------------------------------------------------------------------------
//	007 2010.10.31
//	EvO̐ by A.Ohta
// ---------------------------------------------------------------------------
//	006 2010.10.04
//	EPIC24FJ64GA002 p SHT-11 xZT[Rg[̒ǉ by A.Ohta
// ---------------------------------------------------------------------------
//	005 2010.10.02
//	EPIC24FJ64GA002 ɑΉ̈וύX@by A.Ohta
// ---------------------------------------------------------------------------
//	004 2010.08.18
//	EI/O_̏C@by A.Ohta
// ---------------------------------------------------------------------------
//	003 2010.08.07
//	ESHT-11 C^[tF[XI[vhCɑΉ@by A.Ohta
// ---------------------------------------------------------------------------
//	002 2010.07.30
//	EUSARTɂRS232CʐMɕύXB@by A.Ohta
// ---------------------------------------------------------------------------
//	001 2010.05.16
//	EVK쐬@PIC 16F886 3.3V 쓮pɕύX@by@A.Ohta
// ===========================================================================

// ***************************************************************************
// ***************************************************************************
// *	CN[ht@C												 *
// ***************************************************************************
// ***************************************************************************

#include	"p24FJ64GA004.h"

	//	***** 錾 *****

#include	"_AtrDef24f.h"												//	萔Af[^^̐錾

	//	*****  *****

#include	"device.h"													//	foCX

// ***************************************************************************
// *	zdl																 *
// ***************************************************************************
/*
	PIC24F SDJ[h ]TvvO	PIC24FJ64GA002  CLOCK:8MHz Vdd = 3.3V

	RA0:DATA				PIC <->	SHT			output,input "1"(o)@for SPI
	RA1:SCK					PIC ->	SHT			output"0" for SPI
	RA2:PSWYel				PIC <- 	PSWYel		input "1"
	RA3:PSWBlu				PIC <- 	PSWBlu		input "1"
	RA4:SOSCO									input "1"	Rs = 1M,X1:32.768kHz,C = 15pF for RTCC
	RA												  "1"
	RA												  "1"
	RA7:igpj									input "1"	gp|[g͓͐ݒƂBid팸ׁ̈j
	RA8:RED1				PIC -> LED1			output"0"
	RA9:igpj									input "1"	gp|[g͓͐ݒƂBid팸ׁ̈j
	RA10:igpj									input "1"	gp|[g͓͐ݒƂBid팸ׁ̈j

	RB0:igpj									input "1"	gp|[g͓͐ݒƂBid팸ׁ̈j
	RB1:igpj									input "1"	gp|[g͓͐ݒƂBid팸ׁ̈j
	RP2:UART1 RX			PIC <- PC			input "1"
	RP3:UART1 TX			PIC -> PC			output"0"
	RB4:SOSCI									input "1"	X1:32.768kHz,C = 15pF@for RTCC
	RB5:DRDY 				PIC <- SCP1000		input "1"
	RB6:MISO				PIC <- SCP1000		input "1"
	RB7:CSB					PIC -> SCP1000		output"0"

	RB8:SCK					PIC -> SCP1000		output"0"
	RB9:MOSI				PIC -> SCP1000		output"0"
	RB11:(INV)RES			PIC -> GLCD			output"0"
	RB12:D/C				PIC -> GLCD			output"0"
	RB13:SLCK				PIC -> GLCD			output"0"
	RB14:igpj									input "1"	gp|[g͓͐ݒƂBid팸ׁ̈j
	RB15:(INV)SCE			PIC -> GLCD			output"0"

	RC0:SCK					PIC -> SDCard		output"0"	SD:5pin CLK/SCLK
	RC1:SDO					PIC -> SDCard		output"0"	SD:2pin CMD/DI
	RC2:CS					PIC -> SDCard		output"0"	SD:1pin CD/DAT3
	RC3:SDI					PIC <- SDCard		input "1"	SD:7pin DAT0
	RC4:WE					PIC <- SDCard		input "1"	SD:10pin WP
	RC5:CD					PIC <- SDCard		input "1"	SD:11pin CDI#
	RC6:igpj									input "1"	gp|[g͓͐ݒƂBid팸ׁ̈j
	RC7:igpj									input "1"	gp|[g͓͐ݒƂBid팸ׁ̈j

	RC8:PSWGrn				PIC <- PSWGrn		input "1"
	RC9:PSWGry				PIC <- PSWGry		input "1"

*/

// ***************************************************************************
// *																	 *
// ***************************************************************************

/// RtBM[V rbg̐ݒ
	_CONFIG1(
			JTAGEN_OFF												// JTAG̎gpF
		&	GCP_OFF													// R[hveNgFȂ
		&	GWRP_OFF												// ݃veNgFȂ
		&	BKBUG_OFF												// obNOEhfobOF
		&	COE_OFF													// NbvIG~[VF
		&	ICS_PGx1												// EMUC/EMUDPCG1/PGD1Ƌp
		&	FWDTEN_OFF												// WDTF
	) 

//  Fosc = FRCPLL(8MHz * 4 / 1 = 32MHz ,or 8MHz * 4 / 2 = 16MHz) Fcy = 16MHz ,or Fcy = 8MHz
	_CONFIG2(
			IESO_OFF												// QxX^[gAbvF
		&	FNOSC_FRCPLL											// ȖIFFRCÎ܂܃_CNgɎgpi(PLL)
		&	FCKSM_CSDCMD											// NbN؂ւENbNj^Fɖ
		&	OSCIOFNC_ON												// OSCOs@\FOSCO܂Fosc/2̏o͂ȂARA3 ditital I/O
		&	IOL1WAY_OFF												// RPWX^veNgFveNgȂ
		&	I2C1SEL_PRI												// I2C1̃sIFsgp
		&	POSCMOD_NONE											// 唭UFgpȂ
)

// ***************************************************************************
// ***************************************************************************
// *	Œl																 *
// ***************************************************************************
// ***************************************************************************

//								  5432109876543210
#define	INIT_PORTA_DIR			0b1111111011111101 					//	|[gAo͕ gp|[g͓͐ݒƂBid팸ׁ̈j
#define	INIT_PORTB_DIR			0b0100000001110111 					//	|[gBo͕ gp|[g͓͐ݒƂBid팸ׁ̈j
#define	INIT_PORTC_DIR			0b1111111111111000 					//	|[gCo͕ gp|[g͓͐ݒƂBid팸ׁ̈j

// ***************************************************************************
// ***************************************************************************
// *	\																 *
// ***************************************************************************
// ***************************************************************************


// ***************************************************************************
// ***************************************************************************
// *	O[oϐ															 *
// ***************************************************************************
// ***************************************************************************


// ***************************************************************************
// ***************************************************************************
// *	e[u																 *
// ***************************************************************************
// ***************************************************************************


// ***************************************************************************
// ***************************************************************************
// *	}N錾																 *
// ***************************************************************************
// ***************************************************************************

	//	***** delay ֐p@Fcy *****

#define	CLOCK	8														//  PIC24Fł͒PʂMHzŎw:set to CLOCK with MHz, Fosc = 16MHz,Fcy = 8MHz
																		//  1/2 of system's clock .(MIPSl)
// ***************************************************************************
// ***************************************************************************
// *	vg^Cv錾															 *
// ***************************************************************************
// ***************************************************************************

// ***************************************************************************
// ***************************************************************************
// *	{																 *
// ***************************************************************************
// ***************************************************************************

//	
//	
//
// 		{
//
//	
//	
void	DevStd______(void) {}											//	op֐

//============================================================================
//	ݒ
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	ohb}CRݒ肵܂B
//			Zbg̏lōςޏꍇ͍Đݒ肵Ă܂B
//============================================================================
void	DevInit(void)
{
	//	***** { *****

	//	***** o̓|[g *****

	//I/Oݒ
	CLKDIVbits.RCDIV = 1;							// set 2:1	Fosc = 16MHz,Fcy = 8MHz
	AD1PCFG = 0xFFFF;   							// AD@Set to all Digital I/O ports.

	TRISA = INIT_PORTA_DIR;
	TRISB = INIT_PORTB_DIR;
	TRISC = INIT_PORTC_DIR;

	CNPU1 = 0x0000;									// Pull Up setting for CN4(RB0),CN5(RB1)
	CNPU2 = 0x7600;									// Pull Up setting for CN30(RA2),CN29(RA3),CN28(RC5),CN26(RC3),CN25(RC4)

	LATAbits.LATA0 = 0;								// init for SHT-11 SPI DATA interface RA0 set to Low.

	ODCB = 0x0000;									// all I/O port is set to Push Pull out put.

	/// SPĨst
	RPINR20bits.SDI1R = 19;			// SDIRC3
	RPOR8bits.RP16R = 8;			// SCKRC0
	RPOR8bits.RP17R = 7;			// SDORC1

}

// ***************************************************************************
// ***************************************************************************
// *																		 *
// ***************************************************************************
// ***************************************************************************

//	Copyright 2010 PaletteSoft LLC

