
//	Copyright AsakusaGiken Co., LTD. & Copyright 2010 Ohtan's Design & Co. Copyright 2010 PaletteSoft LLC

//	*     *   ***   ******* *     *                                           
//	**   **  *   *     *    **    *                                           
//	* * * * *     *    *    * *   *                                           
//	*  *  * *     *    *    *  *  *                                           
//	*     * *******    *    *   * *                                           
//	*     * *     *    *    *    **                                           
//	*     * *     * ******* *     *                                           

// ===========================================================================
// =	CL^																 =
// ===========================================================================
//	005 2011.08.15				00.10
//	ESPIobt@[toꕔCB
// ---------------------------------------------------------------------------
//	004 2011.02.23				00.06
//	EsvȊOϐ̐錾폜B
// ---------------------------------------------------------------------------
//	003 2011.01.31				00.05
//	ERgȂǂ̃eiXB
// ---------------------------------------------------------------------------
//	002 2011.01.12				00.04
//	E\̂܂Ƃ߁B Device.c Device.h ^pB
// ---------------------------------------------------------------------------
//	001 2010.12.26				00.01
//	EVK쐬 PIC24FJ64GA004 Air3-24GSSD ڐA LCD̂
// ===========================================================================

/*
Title:			sample proglam 1 for PIF24FJ64GA004
Environment:	MPLAB v8.6 + C30
Hardware:		Air3-24GSD
Date:			Dec. the 18th 2010

The author of this original program is (c)AsakusaGiken Co., LTD.

And this program was changed by Ohtan's Desaign Co. for PIC24FJ64GA004.
*/

#include <p24FJ64GA004.h>

#include "_AtrDef24f.h"

#include "device.h"
#include "nokiaGlcdlib.h"

// ***************************************************************************
// ***************************************************************************
// *	Œl																 *
// ***************************************************************************
// ***************************************************************************

#define true 1
#define false -1
#define HIGH 1
#define LOW 0
//---SD micro card (SPI mode)---
#define SPI1_CS LATCbits.LATC2
#define SDI1 PORTCbits.RC3
#define SDO1 LATCbits.LATC1
#define SCK1 LATCbits.LATC0
#define LED LATAbits.LATA8
#define LED_OFF 1
#define LED_ON 0

/********************************/
/*			O[oϐ			*/
/********************************/
long SDblockLength;				//SDJ[h̃ubN\
char SDreadBuffer[512];			//SDJ[hǂݍ݃obt@
char SDwriteBuffer[512];		//SDJ[h݃obt@

char t0;
char t1;
char t2;
char t3;
char t4;
char t5;
char t6;
char t7;
char t8;
char t9;
char t10;

// ***************************************************************************
// ***************************************************************************
// *	vg^Cv錾															 *
// ***************************************************************************
// ***************************************************************************

int initMicroSD(void);
void brink(void);
void lowbrink(void);
int CMD16(long);
int CMD17(long);
int CMD24(long);

/********************************/
/*			C[v				*/
/********************************/
int main(void)
{
	int cnt;

	LED = LED_OFF;

	DevInit();
	LCD_init();															// @LCD

	LCD_locate(0,0);
	LCD_clear(LCD_WIDTH * LCD_BANKS);									//  LCDNA

	print_version();													//  LCDɃvO Version \
	delay_ms(3000);

	LCD_locate(0,0);
	LCD_clear(LCD_WIDTH * LCD_BANKS);									//  LCDNA

	print_fonts((char *)"SPI Init!",0,0);

	//---SDMicroJ[hSPI[hڍsƏ(sꍇLCD\LED_E~)
	if(initMicroSD() != 0x00){
		LED = LED_ON;
		print_fonts((char *)"SPI Init Error!",0,0);
		while(1);
	}

	print_fonts((char *)"SPI Init OK!",0,0);

	//---SDMicro1ubN512oCgɐݒ(sꍇ	LCD\LED_E~)
	SDblockLength = 512;
	print_fonts((char *)"512 set!",0,1);
	if(CMD16(SDblockLength) != 0x00){		//)CMD16()̈long^@C30̏ꍇAintɂȂ̂Őw̏ꍇ͌^ϊKv@) (long)(512)
		print_fonts((char *)"512 set NG!",0,1);
		LED = LED_ON;
		while(1);
	}
	print_fonts((char *)"512 set OK!",0,1);
	
	//---SDJ[hǂݏoeXg---
	for(cnt=0; cnt<512; cnt++){											//[hobt@NA
		SDreadBuffer[cnt]=0;
	}
	print_fonts((char *)"Read!",0,2);
	cnt = CMD17((long)0x00000);											//擪TPQoCgǂݍ
	for(cnt=0; cnt<512; cnt++){											//ǂݍ݃f[^Cgobt@ɃRs[
		SDwriteBuffer[cnt] = SDreadBuffer[cnt];
	}

	SDwriteBuffer[0] = 'H';												//Cgobt@̓eꕔύX
	SDwriteBuffer[1] = 'e';
	SDwriteBuffer[2] = 'l';
	SDwriteBuffer[3] = 'l';
	SDwriteBuffer[4] = 'o';
	print_fonts((char *)"Write!",0,2);
	cnt = CMD24((long)0x00000);											//擪TPQoCg
	cnt = CMD17((long)0x00000);											//ēǂݍ݁iWatchSDreadBuffer̒ĊmF)

	print_fonts((char *)"Job end!",0,2);
	//---LED3_---
	for(cnt=0; cnt<3; cnt++){
		lowbrink();
	}
	while(1);

}

/********************************/
/*			LED_				*/
/********************************/
void brink(void)
{
	LED = LED_ON;
	delay_ms(70);
	LED = LED_OFF;
	delay_ms(70);
}

/********************************/
/*			ᑬLED_			*/
/********************************/
void lowbrink(void)
{
	LED = LED_ON;
	delay_ms(200);
	LED = LED_OFF;
	delay_ms(200);
}

/************************************************/
/*			SPI1̑Mobt@ɂPoCg			*/
/************************************************/
void WriteSPI1(unsigned int data_out)
{   
    if (SPI1CON1bits.MODE16)          /*word write*/
        SPI1BUF = data_out;
    else 
        SPI1BUF = data_out & 0xff;    /*byte write(default)  */
    while(!SPI1STATbits.SPIRBF);			//MԂɂȂ܂ő҂.
    data_out = SPI1BUF;               	//Avoiding overflow when reading
}

/************************************************/
/*			SPI1 PoCgM						*/
/************************************************/
unsigned int ReadSPI1(void)
{   
	SPI1STATbits.SPIROV = 0;			//MI[o[t[tOZbg
	WriteSPI1 (0xFF);					//_~[
	return SPI1BUF;						//ʃ^[
}


/****************************************************/
/*			MicroSD(SPI1) ݒ					*/
/*			߂lF	ŌCMD1̃^[l				*/
/*					0x00:I						*/
/*					0x01:̂܂܏I				*/
/*					0xFF:rW[̂܂܏I				*/
/*						(IȖFF)				*/
/*					̑:					*/
/****************************************************/
int initMicroSD(void)
{
	int i,error_code,res;
	error_code = 0xFF;
	SPI1_CS=HIGH;				//CSHigh
	//---SPI1̐ݒ---
	SPI1CON1bits.MSTEN = 1;		//}X^[[hɐݒ
	SPI1CON1bits.CKP = 1;		//NbÑAChԂHighɐݒ
	//---SPI[hڍs̓Xs[h400kHzȉ̕Kv---
	SPI1CON1bits.SPRE = 2;		//2nd Pre = 2:1
	SPI1CON1bits.PPRE = 1;		//1st Pre = 16:1 ...Fcy/(2x16)=8/32=250.0KHz
	SPI1STATbits.SPIROV = 0;	//MNA
	SPI1STATbits.SPIEN = 1;		//SPI1L
	//---MicroSD̃ZbgiSPI[hj---
	//(1)dグMMC[h
	//(2)80NbÑ_~[NbN
	for(i=0; i<10; i++){
		WriteSPI1(0xFF);		//80NbNMil0xFFj
	}
	//(3)CSLɂCMD0(CRCt)𔭍s   
	SPI1_CS=LOW;
   	WriteSPI1(0x40);			//CMD0:Zbg SPI[hֈڍs
   	WriteSPI1(0x00); 			//P
   	WriteSPI1(0x00); 			//Q
   	WriteSPI1(0x00); 			//R
   	WriteSPI1(0x00); 			//S	
   	WriteSPI1(0x95); 			//CRC7
	//(4)f[^CɃX|X(x01)
	while(ReadSPI1()!=0x01);	//0x01҂@*v^CAEgݒ
	//(5)CMD1𔭍sBX|X(0x01) *SDHC^CṽJ[h̏ꍇCMD8𔭍sBX|X0x010x00ȂSDHC̉\Aȉ̏قȂ̂Œ
	//(6)X|X0x00ɂȂ܂CMD1𔭍sBB
	do{
		SPI1_CS = HIGH;			//(ȉRsj
		WriteSPI1(0xFF);
		SPI1_CS = LOW;
		WriteSPI1(0x41);		//CMD1:&󋵊mFiX|X0x01͏A0x00͏Ij
		WriteSPI1(0x00); 		//P
	   	WriteSPI1(0x00); 		//Q
	   	WriteSPI1(0x00); 		//R
	   	WriteSPI1(0x00); 		//S	
	   	WriteSPI1(0xF9); 		//CRC7(ۂɂSPI[hȂ̂Ŗ)
		for(i=0; i<32700; i++){	//X|X`FbNiʏ͐ŃR}hX|XԂj
			res = ReadSPI1();
			if (res != 0xFF) break;	//X|X]ArW[(0xFF)oȂ烊gC
		}
	}while(res != 0x00);		//*v^CAEgݒ
	//(7)MMC[hւ̈ڍs͓dOFF/ON
	WriteSPI1(0xFF);			//_~[NbNM
   	SPI1_CS=HIGH;				//MicroSDݒ胋[`I
   	//(8)ʐMxĐݒiNbNŐłōƁAu]x12MB/sṽJ[hŃRPBj 	
	SPI1STATbits.SPIEN = 0;		//SPI1
	Nop();
	SPI1CON1bits.SPRE = 2;		//2nd Pre = 2:1
	SPI1CON1bits.PPRE = 3;		//1st Pre = 1:1 ...Fcy/(2x1)=8/2=4.0MHz(0.5MB/s)
	SPI1STATbits.SPIEN = 1;		//SPI1L
   	error_code = res;
   	return error_code;
}


/****************************************************/
/*			MicroSD R}hsiR1X|Xj				*/
/****************************************************/
int CMD(char CMD, char arg1, char arg2, char arg3, char arg4, char crc)
{
	int i,res;
	//---OԂrꍇlĒʐMԃNA---
	SPI1_CS = HIGH;
//	WriteSPI1(0xFF);
	delay_ms(1);
	SPI1_CS = LOW;
	//(1)R}hs
	WriteSPI1(0x40+CMD);	//CMD
	WriteSPI1(arg1); 		//P
  	WriteSPI1(arg2); 		//Q
  	WriteSPI1(arg3); 		//R
  	WriteSPI1(arg4); 		//S	
  	WriteSPI1(crc); 		//CRC7(SPI[h̏ꍇ͖̂ŉłǂ)	
	//(2)X|X҂
	for(i=0; i<32700; i++){	//X|X`FbNiʏ͐ŃR}hX|XԂj
		res = ReadSPI1();
		if (res != 0xFF) break;	//X|X]ArW[(0xFF)oȂ烊gC
	}
	return res;
	//---̊֐̓R}hs烌X|X܂ŁB̌CS̏E_~[NbNsȂǂ͌ĂяoōsB---
}


/****************************************************/
/*			MicroSD ubN̐ݒ						*/
/*			blockLengthŐݒ肵lPubNɐݒ		*/
/*			(long^Ȃ̂ŌĂяo̒l̓n		*/
/*			 ɒӁB@CMD16(512); ł̓G[ɂȂB			*/
/*			 CMD16((long)(512));@ƂKvB		*/
/*			 C30L̖ƎvB)					*/
/****************************************************/
int CMD16(long blockLength)
{
	char a1,a2,a3,a4;
	int cmd16_res;
	//(1)ubNSoCg̈ɕϊ
	a1 = (char)((blockLength & 0xFF000000)>>24);
	a2 = (char)((blockLength & 0x00FF0000)>>16);
	a3 = (char)((blockLength & 0x0000FF00)>>8);
	a4 = (char)(blockLength & 0x000000FF);
	//(2)CMDs`X|X
	cmd16_res = CMD(16,a1,a2,a3,a4,0x00);	//CMD16sAX|X擾
	//(3)I
	WriteSPI1(0xFF);						//_~[NbNM
   	SPI1_CS=HIGH;							//I
	return cmd16_res;						//CMD16̃X|XʂԐM
}

/****************************************************/
/*			MicroSD 1ubNǂݏo					*/
/*			dataAddressŎw肵ꏊCMD16Őݒ		*/
/*			ubNǂݍSDreadBuffer			*/
/*			Ɋi[B									*/
/****************************************************/
int CMD17(long dataAddress)
{
	char a1,a2,a3,a4,dummy;
	int cmd17_res,i;
	//(1)ubNSoCg̈ɕϊ
	a1 = (char)((dataAddress&0xFF000000)>>24);
	a2 = (char)((dataAddress&0x00FF0000)>>16);
	a3 = (char)((dataAddress&0x0000FF00)>>8);
	a4 = (char)(dataAddress&0x000000FF);
	//(2)CMDs`X|X
	cmd17_res = CMD(17,a1,a2,a3,a4,0xFF);	//CMD17sAX|X擾
	if(cmd17_res != 0x00){					//X|X0x00(G[Ȃ)ȊO瑦IB
		WriteSPI1(0xFF);						//I
	   	SPI1_CS=HIGH;		
		return cmd17_res;
	}
	//(3)f[^g[NX^[goCg(0xFE)҂
	for(i=0; i<32700; i++){					//rW[`FbN
		cmd17_res = ReadSPI1();
		if (cmd17_res != 0xFF) break;		//rW[(0xFF)oȂ烊gC
	}
	//(4)f[^ǂݏo
	if (cmd17_res == 0xFE){
		for (i=0; i<(int)SDblockLength; i++)
		{
			SDreadBuffer[i] = ReadSPI1();
		}
	}
	//(5)CRC2oCgǂݍ݁iłCRC͎gĂ܂񂪎dlȂ̂ňꉞQoCgǂłj
	dummy = ReadSPI1();
	dummy = ReadSPI1();
	//(6)I
	WriteSPI1(0xFF);						//_~[NbNM
   	SPI1_CS=HIGH;							//I
	return cmd17_res;						//CMD17̃X|XʂԐM@펞0xFEԐM
}


/************************************************************************************/
/*			MicroSD 1ubN														*/
/*			炩SDwriteBuffer[]ɏꂽf[^										*/
/*			MicroSDɏށB															*/
/*			߂lF	݂܂ōsꍇ̓f[^X|XԂBȊO̓R}hX|XԂ		*/
/*					0xFF:R}hsrW[̂܂܏I										*/
/*					0x?5:f[^͎󂯓ꂽ											*/
/*					0x?B:CRCG[ŋۂꂽ											*/
/*					0x?D:CgG[													*/
/************************************************************************************/
int CMD24(long dataAddress)
{
	char a1,a2,a3,a4,dummy;
	int cmd24_res,i;
	//(1)ubNSoCg̈ɕϊ
	a1 = (char)((dataAddress & 0xFF000000)>>24);
	a2 = (char)((dataAddress & 0x00FF0000)>>16);
	a3 = (char)((dataAddress & 0x0000FF00)>>8);
	a4 = (char)(dataAddress & 0x000000FF);
	//(2)CMDs`X|X
	cmd24_res = CMD(24,a1,a2,a3,a4,0xFF);	//CMD24sAX|X擾
	if(cmd24_res != 0x00){					//X|X0x00(G[Ȃ)ȊO瑦IB
		WriteSPI1(0xFF);						//I
	   	SPI1_CS=HIGH;		
		return cmd24_res;
	}
	//(3)f[^g[NX^[goCg(0xFE)
	WriteSPI1(0xFE);
	//(4)f[^
	for (i=0; i<(int)SDblockLength; i++)
	{
		WriteSPI1(SDwriteBuffer[i]);	//f[^݂ubN
	}
	//(5)CRCM
	dummy = ReadSPI1();					//CRCQoCg݁iSPI[hȂ̂ňӖȂj
	dummy = ReadSPI1();
	//(6)f[^X|XM
	cmd24_res = ReadSPI1();				//f[^X|X
	//(7)rW[҂
	for(i=0; i<32700; i++){				//ɃrW[Ȃꍇ̂ő߂ɔBĂяoŏ݌シɓǂݍłf[^fȂꍇ̓RRŃrW[Ȃ\B
		if(ReadSPI1() != 0x00) break;
	}
	//(8)I
	WriteSPI1(0xFF);						//_~[NbNM
   	SPI1_CS=HIGH;							//I
	return cmd24_res;						//CMD17̃X|XʂԐM@펞0xFEԐM
}

// ***************************************************************************
// ***************************************************************************
// *																		 *
// ***************************************************************************
// ***************************************************************************

//	Copyright AsakusaGiken Co., LTD. & Copyright 2010 Ohtan's Design & Co. Copyright 2010 PaletteSoft LLC

