
//	Copyright 2010 Ohtan's Design Corporation

//	nokiaGlcdlib.c

// ===========================================================================
// =	CL^										@@@@@@					 =
// ===========================================================================
//	009 2010.11.17
//	Ee[u̒ǉAύXALCDփvO"Ver." ̕\s
// ---------------------------------------------------------------------------
//	008 2010.11.14
//	ELCDփvOVersion ̕\Ȃ
// ---------------------------------------------------------------------------
//	007 2010.11.13
//	Eϑf[^[̃[ւ̋L
// ---------------------------------------------------------------------------
//	006 2010.10.31
//	E{^֌W̕ύX
// ---------------------------------------------------------------------------
//	005 2010.10.31
//	EvO̐
// ---------------------------------------------------------------------------
//	004 2010.10.17
//	EPIC24FJ64GA002 RTCC ɂtA̕t
// ---------------------------------------------------------------------------
//	003 2010.10.13
//	Ezdl̕ύX Pʕ\̃LN^[ύXieϑf[^Pʂ܂߂ĂPsŕ\ł悤ɂj
// ---------------------------------------------------------------------------
//	002 2010.09.23
//	EC
// ---------------------------------------------------------------------------
//	001 2010.09.23
//	EVK쐬
//  Crated by A.Ohta
// ===========================================================================

// ***************************************************************************
//		mLA5110LCD쓮pCu[
// ***************************************************************************

// ***************************************************************************
// ***************************************************************************
// *	CN[ht@C														 *
// ***************************************************************************
// ***************************************************************************
#include "p24FJ64GA004.h"

#include "_AtrDef24f.h"

#include "nokiaGlcdlib.h"
#include "version.h"

// ***************************************************************************
// ***************************************************************************
// *	Œl																 *
// ***************************************************************************
// ***************************************************************************

// ***************************************************************************
// ***************************************************************************
// *	O[oϐ															 *
// ***************************************************************************
// ***************************************************************************

UINT LCD_MAX_PRES;
UINT LCD_MIN_PRES;

UINT LCD_MAX_TEMP;
UINT LCD_MIN_TEMP;

UINT LCD_MAX_RHUM;
UINT LCD_MIN_RHUM;

UH MemPres[48];															//  \pCf[^̋L̈
UH MemTemp[48];															//  \pxf[^̋L̈
int MemRhum[48];														//  \pxf[^̋L̈

// ***************************************************************************
// ***************************************************************************
// *	e[u																 *
// ***************************************************************************
// ***************************************************************************

unsigned char const FontLookup[][5] =
{
{ 0x00, 0x00, 0x00, 0x00, 0x00 }, // sp
{ 0x00, 0x00, 0x2f, 0x00, 0x00 }, // !
{ 0x00, 0x07, 0x00, 0x07, 0x00 }, // "
{ 0x14, 0x7f, 0x14, 0x7f, 0x14 }, // #
{ 0x24, 0x2a, 0x7f, 0x2a, 0x12 }, // $
{ 0xc4, 0xc8, 0x10, 0x26, 0x46 }, // %
{ 0x36, 0x49, 0x55, 0x22, 0x50 }, // &
{ 0x00, 0x05, 0x03, 0x00, 0x00 }, // '
{ 0x00, 0x1c, 0x22, 0x41, 0x00 }, // (
{ 0x00, 0x41, 0x22, 0x1c, 0x00 }, // )
{ 0x14, 0x08, 0x3E, 0x08, 0x14 }, // *
{ 0x08, 0x08, 0x3E, 0x08, 0x08 }, // +
{ 0x00, 0x00, 0x50, 0x30, 0x00 }, // ,
{ 0x10, 0x10, 0x10, 0x10, 0x10 }, // -
{ 0x00, 0x60, 0x60, 0x00, 0x00 }, // .
{ 0x20, 0x10, 0x08, 0x04, 0x02 }, // /
{ 0x3E, 0x41, 0x41, 0x41, 0x3E }, // 0
{ 0x00, 0x42, 0x7F, 0x40, 0x00 }, // 1
{ 0x42, 0x61, 0x51, 0x49, 0x46 }, // 2
{ 0x21, 0x41, 0x45, 0x4B, 0x31 }, // 3
{ 0x18, 0x14, 0x12, 0x7F, 0x10 }, // 4
{ 0x27, 0x45, 0x45, 0x45, 0x39 }, // 5
{ 0x3C, 0x4A, 0x49, 0x49, 0x30 }, // 6
{ 0x01, 0x71, 0x09, 0x05, 0x03 }, // 7
{ 0x36, 0x49, 0x49, 0x49, 0x36 }, // 8
{ 0x06, 0x49, 0x49, 0x29, 0x1E }, // 9
{ 0x00, 0x36, 0x36, 0x00, 0x00 }, // :
{ 0x00, 0x56, 0x36, 0x00, 0x00 }, // ;
{ 0x08, 0x14, 0x22, 0x41, 0x00 }, // <
{ 0x14, 0x14, 0x14, 0x14, 0x14 }, // =
{ 0x00, 0x41, 0x22, 0x14, 0x08 }, // >
{ 0x02, 0x01, 0x51, 0x09, 0x06 }, // ?
{ 0x32, 0x49, 0x59, 0x51, 0x3E }, // @
{ 0x7E, 0x11, 0x11, 0x11, 0x7E }, // A
{ 0x7F, 0x49, 0x49, 0x49, 0x36 }, // B
{ 0x3E, 0x41, 0x41, 0x41, 0x22 }, // C
{ 0x7F, 0x41, 0x41, 0x22, 0x1C }, // D
{ 0x7F, 0x49, 0x49, 0x49, 0x41 }, // E
{ 0x7F, 0x09, 0x09, 0x09, 0x01 }, // F
{ 0x3E, 0x41, 0x49, 0x49, 0x7A }, // G
{ 0x7F, 0x08, 0x08, 0x08, 0x7F }, // H
{ 0x00, 0x41, 0x7F, 0x41, 0x00 }, // I
{ 0x20, 0x40, 0x41, 0x3F, 0x01 }, // J
{ 0x7F, 0x08, 0x14, 0x22, 0x41 }, // K
{ 0x7F, 0x40, 0x40, 0x40, 0x40 }, // L
{ 0x7F, 0x02, 0x0C, 0x02, 0x7F }, // M
{ 0x7F, 0x04, 0x08, 0x10, 0x7F }, // N
{ 0x3E, 0x41, 0x41, 0x41, 0x3E }, // O
{ 0x7F, 0x09, 0x09, 0x09, 0x06 }, // P
{ 0x3E, 0x41, 0x51, 0x21, 0x5E }, // Q
{ 0x7F, 0x09, 0x19, 0x29, 0x46 }, // R
{ 0x46, 0x49, 0x49, 0x49, 0x31 }, // S
{ 0x01, 0x01, 0x7F, 0x01, 0x01 }, // T
{ 0x3F, 0x40, 0x40, 0x40, 0x3F }, // U
{ 0x1F, 0x20, 0x40, 0x20, 0x1F }, // V
{ 0x3F, 0x40, 0x38, 0x40, 0x3F }, // W
{ 0x63, 0x14, 0x08, 0x14, 0x63 }, // X
{ 0x07, 0x08, 0x70, 0x08, 0x07 }, // Y
{ 0x61, 0x51, 0x49, 0x45, 0x43 }, // Z
{ 0x00, 0x7F, 0x41, 0x41, 0x00 }, // [
{ 0x55, 0x2A, 0x55, 0x2A, 0x55 }, // 55
{ 0x00, 0x41, 0x41, 0x7F, 0x00 }, // ]
{ 0x04, 0x02, 0x01, 0x02, 0x04 }, // ^
{ 0x40, 0x40, 0x40, 0x40, 0x40 }, // _
{ 0x00, 0x01, 0x02, 0x04, 0x00 }, // '
{ 0x20, 0x54, 0x54, 0x54, 0x78 }, // a
{ 0x7F, 0x48, 0x44, 0x44, 0x38 }, // b
{ 0x38, 0x44, 0x44, 0x44, 0x20 }, // c
{ 0x38, 0x44, 0x44, 0x48, 0x7F }, // d
{ 0x38, 0x54, 0x54, 0x54, 0x18 }, // e
{ 0x08, 0x7E, 0x09, 0x01, 0x02 }, // f
{ 0x0C, 0x52, 0x52, 0x52, 0x3E }, // g
{ 0x7F, 0x08, 0x04, 0x04, 0x78 }, // h
{ 0x00, 0x44, 0x7D, 0x40, 0x00 }, // i
{ 0x20, 0x40, 0x44, 0x3D, 0x00 }, // j
{ 0x7F, 0x10, 0x28, 0x44, 0x00 }, // k
{ 0x00, 0x41, 0x7F, 0x40, 0x00 }, // l
{ 0x7C, 0x04, 0x18, 0x04, 0x78 }, // m
{ 0x7C, 0x08, 0x04, 0x04, 0x78 }, // n
{ 0x38, 0x44, 0x44, 0x44, 0x38 }, // o
{ 0x7C, 0x14, 0x14, 0x14, 0x08 }, // p
{ 0x08, 0x14, 0x14, 0x18, 0x7C }, // q
{ 0x7C, 0x08, 0x04, 0x04, 0x08 }, // r
{ 0x48, 0x54, 0x54, 0x54, 0x20 }, // s
{ 0x04, 0x3F, 0x44, 0x40, 0x20 }, // t
{ 0x3C, 0x40, 0x40, 0x20, 0x7C }, // u
{ 0x1C, 0x20, 0x40, 0x20, 0x1C }, // v
{ 0x3C, 0x40, 0x30, 0x40, 0x3C }, // w
{ 0x44, 0x28, 0x10, 0x28, 0x44 }, // x
{ 0x0C, 0x50, 0x50, 0x50, 0x3C }, // y
{ 0x44, 0x64, 0x54, 0x4C, 0x44 } // z
};

/* uhPav */
unsigned char const font_hPa[] = 
{
	0b11111110,
	0b00001000,
	0b11111000,
	0b00000000,
	0b11111110,
	0b00010010,
	0b00001100,
	0b01000000,
	0b10101000,
	0b01110000,
};

/* mini */
unsigned char const font_mnum[][3]=
{
	{ /* 0 */
	0b11111110,
	0b10000010,
	0b11111110,
	},

	{ /* 1 */
	0b00000100,
	0b11111110,
	0b00000000,
	},

	{ /* 2 */
	0b11110110,
	0b10010010,
	0b10011110,
	},

	{ /* 3 */
	0b10010010,
	0b10010010,
	0b11111110,
	},

	{ /* 4 */
	0b00011110,
	0b00010000,
	0b11111110,
	},

	{ /* 5 */
	0b10011110,
	0b10010010,
	0b11110010,
	},

	{ /* 6 */
	0b11111100,
	0b10010010,
	0b11110010,
	},

	{ /* 7 */
	0b00001110,
	0b00000010,
	0b11111110,
	},

	{ /* 8 */
	0b11111110,
	0b10010010,
	0b11111110,
	},

	{ /* 9 */
	0b00011110,
	0b00010010,
	0b11111110,
	},
};

/* miniu/v */
unsigned char const font_mslach[] = 
{
	0b00100000,
	0b00010000,
	0b00001000,
};

/* miniu:v */
unsigned char const font_mcolon[] = 
{
	0b00000000,
	0b01001000,
	0b00000000,
};

/* uv */
unsigned char const font_do[] = 
{
	0b00000000,
	0b00000010,
	0b01110101,
	0b10001010,
	0b10001000,
};

/* u%v */
unsigned char const font_percent[] =
{
	0b00000000,
	0b00100110,
	0b11010110,
	0b11001000,
	0b00000100,
};

/* umemRecv */
unsigned char const font_mrec[] =
{
	0b00111000,
	0b01111100,
	0b01111100,
	0b01111100,
	0b00111000,
};

/* umemrePlayv */
unsigned char const font_mplay[] =
{
	0b11111111,
	0b01111110,
	0b00111100,
	0b00011000,
	0b00000000,
};

//============================================================================
//	mLA5110LCD۰Ư PCD8544 ݒ
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void LCD_init()
{
//  LCDݒ

	SPI_RES = 0;														//  LCD Zbgw	֐Ăяo
	delay_us(10);														//  LCD Zbgێ
	SPI_RES = 1;														//  LCD Zbg	֐Ăяo

	SPI_DC = 0;															//	֐Ăяoă|[gkB̏o͒[q͕⏞
	SPI_SCE = 0;														//  LCD `bvCl[u
	SPI_CLK = 0;														//  ݒ

	SPI_tx_byte(0b00100000 | 1, 0);										//  H = 1
	SPI_tx_byte(0b00000100 | 1, 0);										//  TC = 1 (0-3)
	SPI_tx_byte(0b00010000 | 3, 0);										//  Bais = 3 (0-7)
	SPI_tx_byte(0b10000000 | 68, 0);									//  Vop = 68 (0-127) RgXgݒ
	SPI_tx_byte(0b00100000 | 0, 0);										//  H = 0, Horizontal addressing
	SPI_tx_byte(0b00001000 | 4, 0);										//  Display Mode Normal = 4
	SPI_tx_byte(0b01000000 | 0, 0);										//  Set Y = 0 (0-5)
	SPI_tx_byte(0b10000000 | 0, 0);										//  Set X = 0 (0-83)

	shiftmem_clear();													//	Vtg\pꎞL̈NA

	LCD_MAX_PRES = intLCD_MAX_PRES;										//  vbgłC̍őlݒ肷
	LCD_MIN_PRES = intLCD_MIN_PRES;										//  vbgłC̍ŏlݒ肷

	LCD_MAX_TEMP = intLCD_MAX_TEMP;										//  vbgłC̍őlݒ肷
	LCD_MIN_TEMP = intLCD_MIN_TEMP;										//  vbgłC̍ŏlݒ肷

	LCD_MAX_RHUM = intLCD_MAX_RHUM;										//  vbgł鎼x̍őlݒ肷
	LCD_MIN_RHUM = intLCD_MIN_RHUM;										//  vbgł鎼x̍ŏlݒ肷
}


//============================================================================
//	LCD݈̏ʒu@wAx@ɐݒ肷
//----------------------------------------------------------------------------
//	́F	unsigned char x,unsigned char y
//	óF	
//----------------------------------------------------------------------------
//	lF	0 <= x <= 83, 0 <= y <= 5
//  		 y ͉Eォ牺@LSBŏl̂WrbgP
//  		mLALCD̃Ot́Aオ_B
//============================================================================
void LCD_locate(unsigned char x,unsigned char y)
{
	SPI_tx_byte(0b01000000 | y, 0);										//  Set Y = y
	SPI_tx_byte(0b10000000 | x, 0);										//  Set X = x
}

//============================================================================
//	݂݈̏ʒuwoCg̃f[^
//----------------------------------------------------------------------------
//	́F	unsigned char *datap,int len
//	óF	
//----------------------------------------------------------------------------
//	lF	̃R}hlen̉񐔕xʒu𑝂₵Ȃ牡ւPoNw肳ꂽoCgf[^
//============================================================================
void LCD_set_data(unsigned char *datap,int len)
{
	for (;len>0;len--)
		SPI_tx_byte(*(datap++), 1);
}

//============================================================================
//	݂݈̏ʒuwoCg̕\NA
//----------------------------------------------------------------------------
//	́F	unsigned int len
//	óF	
//----------------------------------------------------------------------------
//	lF	̃R}hlen̉񐔕xʒu𑝂₵Ȃ牡ւPoNNA
//============================================================================
void LCD_clear(unsigned int len)
{
	for (;len>0;len--)
		SPI_tx_byte(0, 1);
}

//============================================================================
//	Data/Command@w肵āALCDɂPoCg𑗐M
//----------------------------------------------------------------------------
//	́F	unsigned char d,int dc
//	óF	
//----------------------------------------------------------------------------
//	lF	dc = 0 : Command, dc = 1 : Data
//============================================================================
void SPI_tx_byte(unsigned char d,int dc)
{
	char Loop;
 

	SPI_SCE = 0;

	SPI_DC = 0;
	if (dc) {
		SPI_DC = 1;
	}

	for (Loop=0;Loop<8;Loop++){
		SPI_DATA = 0;
		if ((d & (unsigned char)0x80) != 0){
			SPI_DATA = 1;
		}
		delay_us(3);
		SPI_CLK = 1;
		d <<= 1;
		delay_us(6);
		SPI_CLK = 0;
	}
	SPI_SCE = 1;
}

//============================================================================
//	Pʂňʒuw肵Đ̐\(F5dotp)
//----------------------------------------------------------------------------
//	́F	int n: int col(end position of clom), int y_bank
//	óF	
//----------------------------------------------------------------------------
//	lF	col :
//============================================================================
void print_num(int n, int col, int y_bank)
{
	int r;
	unsigned char *pc;

	do {
		r = ( n % 10 ) + 16;											//  1ԉ̌̒lvZ
		n = n / 10;
		LCD_locate(col*6, y_bank);										//  \ʒuvZ
		pc = (unsigned char *)(FontLookup[r]);
		LCD_set_data(pc, 5);											//  1ԉ̌̒lɑΉ镶\
		--col;
	} while (n > 0);													//  SĂ̌\܂ŌJԂ
}

//============================================================================
//	Pʂňʒuw肵Đ̐\(F3dotp)
//----------------------------------------------------------------------------
//	́F	int n: int col(end position of clom), int y_bank
//	óF	
//----------------------------------------------------------------------------
//	lF	col :
//============================================================================
void print_mnum(int n, int col, int y_bank)
{
	int r;
	unsigned char *pc;

	do {
		r = n % 10;														//  1ԉ̌̒lvZ
		n = n / 10;
		LCD_locate(col*4, y_bank);										//  \ʒuvZ
		pc = (unsigned char *)(font_mnum[r]);
		LCD_set_data(pc, 3);											//  1ԉ̌̒lɑΉ镶\
		--col;
	} while (n > 0);													//  SĂ̌\܂ŌJԂ
}

//============================================================================
//	C̒P hPa \
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void print_unithps()
{
	unsigned char *pc;

	/* uhPav\ */
	LCD_locate(24, 3);
	pc = (unsigned char *)font_hPa;
	LCD_set_data(pc, 10);
}

//============================================================================
//	x̒P  \
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void print_unitdeg()
{
	unsigned char *pc;

	/* uv\ */
	LCD_locate(29, 4);
	pc = (unsigned char *)font_do;
	LCD_set_data(pc, 5);
}

//============================================================================
//	Ύx̒P % \
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void print_percent()
{
	unsigned char *pc;

	/* u%v\ */
	LCD_locate(29, 5);													// x\̒̈ʒu  
	pc = (unsigned char *)font_percent;
	LCD_set_data(pc, 5);
}

//============================================================================
//	[֌vf[^̋L^ memRec}[N \
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	uv
//============================================================================
void print_mrec()
{
	unsigned char *pc;

	/* umemRecv\ */
	LCD_locate(0, 2);
	pc = (unsigned char *)font_mrec;
	LCD_set_data(pc, 5);
}

//============================================================================
//	[vf[^vC memrePlay}[N \
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	uOpv
//============================================================================
void print_mplay()
{
	unsigned char *pc;

	/* umemrePlayv\ */
	LCD_locate(0, 2);
	pc = (unsigned char *)font_mplay;
	LCD_set_data(pc, 5);
}

//============================================================================
//	mLA5110LCD́@(x, y)sNZWɓ_`悷B
//----------------------------------------------------------------------------
//	́F	int x, int y
//	óF	
//----------------------------------------------------------------------------
//	lF	ÝAŏA㑤őimLALCDY𔽓]ĕ\jB
//			0 <= x <= 83 , 0 <= y <= 47 őnAŏl𒴂Ăꍇ́A͈͓ 
//			NvB 
//============================================================================
void draw_point(int x, int y)
{
	int bank_y;
	unsigned char pat_y;

	if (y < 0) {
		bank_y = LCD_MAX_BANK;											//  Y̒lȂ΁AOt̍ŏlɃNvăvbgB
		pat_y = 0b10000000;												//  LCD̍ő呤ij𐔒l̍ŏƂ邽߁AMSBŏlB
	} else if (y > LCD_MAX_Y) {
		bank_y = 0;														//  Y̒lől𒴂ĂȂ΁AOőlɃNvăvbgB
		pat_y = 0b00000001;												//  LCD̍ŏi㑤j𐔒l̍őƂ邽߁ALSBőlB
	} else {
		bank_y = LCD_MAX_BANK - (y / 8);								//  y]ʒuɃoN
		pat_y = 0b10000000 >> (y % 8);									//  oNMSBŏlƂ邱ƂY\0ƂȂ
	}
	LCD_locate(x, bank_y);												//  xʒũoN
	LCD_set_data(&pat_y, 1);											//  oN8rbgp^[

}

//============================================================================
//	(x, y)sNZWɋC`
//----------------------------------------------------------------------------
//	́F	int x, int prsy
//	óF	
//----------------------------------------------------------------------------
//	lF	\
//============================================================================
void draw_Prespoint(int x, int prsy)
{

	int bank_prsy;
	unsigned char pat_prsy;
																		//  OtԂ̏A͈͓ɒlNvB

	if (prsy < 32 ) {													//  ClCOtԂ̍ŏ͈͂H
		bank_prsy = 1;
		pat_prsy = 0b10000000;
	}
	else if (prsy > 47 ) {												//  ClCOtԂ̍ő͈͂オH
		bank_prsy = 0;
		pat_prsy = 0b00000001;
	}
	else {
		bank_prsy = LCD_MAX_BANK - (prsy / 8);							//  \oNvZ
		pat_prsy = 0b10000000 >> (prsy % 8);							//  oÑrbgʒuvZ
	}
	LCD_locate(x, bank_prsy);											//  xʒuŃoN(C)
	LCD_set_data(&pat_prsy, 1);											//  oN֋C8rbgp^[
}

//============================================================================
//	(x, y)sNZWɋC`
//----------------------------------------------------------------------------
//	́F	int x, int degy
//	óF	
//----------------------------------------------------------------------------
//	lF	\
//============================================================================
void draw_Temppoint(int x, int tempy)
{

	int bank_tempy;
	unsigned char pat_tempy;
																		//  OtԂ̏A͈͓ɒlNvB

	if (tempy < 16 ) {													//  ClCOtԂ̍ŏ͈͂H
		bank_tempy = 3;
		pat_tempy = 0b10000000;
	}
	else if (tempy > 31 ) {												// @ClCOtԂ̍ő͈͂オH
		bank_tempy = 2;
		pat_tempy = 0b00000001;
	}
	else {
		bank_tempy = LCD_MAX_BANK - (tempy / 8);						//  \oNvZ
		pat_tempy = 0b10000000 >> (tempy % 8);							//  oÑrbgʒuvZ
	}
	LCD_locate(x, bank_tempy);											//  xʒuŃoN(C)
	LCD_set_data(&pat_tempy, 1);										//  oN֋C8rbgp^[
}

//============================================================================
//	(x, y)sNZWɎx`
//----------------------------------------------------------------------------
//	́F	int x, int rhy
//	óF	
//----------------------------------------------------------------------------
//	lF	\
//============================================================================
void draw_Rhumpoint(int x, int rhy)
{

	int bank_rhy;
	unsigned char pat_rhy;
																		//  OtԂ̏A͈͓ɒlNvB

	if (rhy < 0 ) {														//  xlxOtԂ̍ŏ͈͂H
		bank_rhy = 5;
		pat_rhy = 0b10000000;
	}
	else if (rhy > 15 ) {												// @xlxOtԂ̍ő͈͂オH
		bank_rhy = 4;
		pat_rhy = 0b00000001;
	}
	else {
		bank_rhy = LCD_MAX_BANK - (rhy / 8);							//  \oNvZ
		pat_rhy = 0b10000000 >> (rhy % 8);								//  oÑrbgʒuvZ

	}
		LCD_locate(x, bank_rhy);										//  xʒuŃoN(x)
		LCD_set_data(&pat_rhy, 1);										//  oNx8rbgp^[
}

//============================================================================
//	OtY\
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void print_Yaxis()
{
	int	x, y;
	unsigned char c;

	c = 0b10101010;
	x = LCD_MAX_X - GRAPH_HIST_MAX;

	//* c\

	for (y = 0; y < 6; y++) {
		LCD_locate(x, y);
		LCD_set_data(&c, 1);
	}

	//* Y݂̍\
	for (y = 0; y <= LCD_MAX_Y; y += 16) {
		draw_point(x - 1, y);
	}
}

//============================================================================
//	Plot X ʒűCOtc݂̈̂NA
//----------------------------------------------------------------------------
//	́F	int plotx
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void graph_plotx_Presclear(int plotx)
{
	int	i;

	for (i=0;i<2;i++){
		LCD_locate(LCD_MAX_X - GRAPH_HIST_MAX + plotx + 1 ,i);
		LCD_clear(1);
		if (plotx < 46){
			LCD_clear(1);
		}
		if (plotx < 47){
			LCD_clear(1);
		}
	}
}

//============================================================================
//	Plot X ʒűCOtc݂̈̂NA
//----------------------------------------------------------------------------
//	́F	int plotx
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void graph_plotx_Tempclear(int plotx)
{
	int	i;

	for (i=2;i<4;i++){
		LCD_locate(LCD_MAX_X - GRAPH_HIST_MAX + plotx + 1 ,i);
		LCD_clear(1);
		if (plotx < 46){
			LCD_clear(1);
		}
		if (plotx < 47){
			LCD_clear(1);
		}
	}
}

//============================================================================
//	Plot X ʒu̎xOtc݂̈̂NA
//----------------------------------------------------------------------------
//	́F	int plotx
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void graph_plotx_Rhumclear(int plotx)
{
	int	i;

	for (i=4;i<6;i++){
		LCD_locate(LCD_MAX_X - GRAPH_HIST_MAX + plotx + 1 ,i);
		LCD_clear(1);
		if (plotx < 46){
			LCD_clear(1);
		}
		if (plotx < 47){
			LCD_clear(1);
		}
	}
}

//============================================================================
//	C𐔒l\
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void print_press(int pdata)
{
	/*@\̈NA */
	LCD_locate(0,3);
	LCD_clear(4 * 6);

	print_num(pdata,3,3);
}


//============================================================================
//	x𐔒l\
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void print_temp(int tempA, int temp_sign)
{
	/*@\̈NA */
	LCD_locate(0,4);
	LCD_clear(5 * 6);

	/* \ */
	if (temp_sign != 0) {
		print_fonts((char *)"-",0,4);
	} else {
		print_fonts((char *)"+",0,4);
	}

	/* x̐l\ij */
	print_num(tempA/10, 2, 4);

	/* _\@*/
	print_fonts((char *)".",3,4);

	/* x̐l\ij */
	tempA = tempA % 10;
	print_num(tempA, 4, 4);

}

//============================================================================
//	Ύx𐔒l\
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void print_RH(int RHA)
{
	/*@\̈NA */
	LCD_locate(0,5);
	LCD_clear(5 * 6);

	/* x̐l\ij */
	print_num(RHA/10, 2, 5);

	/* _\@*/
	print_fonts((char *)".",3,5);

	/* x̐l\ij */
	RHA = RHA % 10;
	print_num(RHA, 4, 5);

}

//============================================================================
//	Cf[^Plot							
//----------------------------------------------------------------------------
//	́F	Cf[^
//	óF	
//----------------------------------------------------------------------------
//	lF
//
//============================================================================
void	MngplotPres(int gX, UW Pres)
{
	int i;
	UH	Value;

	Value = (UH)(Pres / 400L);											//	vlϊBʏ300 `1200͈͓̔̂͂

	MemPres[gX] = Value;												//  Vtgĕ\p̋Cf[^ꎟLB
 
	// Vtg\
	if (Value > LCD_MAX_PRES ) {										//  \̍ől𒴂H
		LCD_MAX_PRES = Value;											//  	݂̒lőƂ臒lɕύXB
		LCD_MIN_PRES = LCD_MAX_PRES - 15 ;								//  	Lőlŏ\͈͒lvZĐݒ肷
		for (i = 0; i < 48 ; i++ ) {									//  	C̗V臒lŃvbg
			print_Presgraph(i, MemPres[i] );
		}
	}
	else if (Value < LCD_MIN_PRES ) {									//  \̍ŏlH
		LCD_MIN_PRES = Value;											//  	݂̒lŏƂ臒lɕύXB
		LCD_MAX_PRES = LCD_MIN_PRES + 15 ;								//  	Lŏlő\͈͒lvZĐݒ肷
		for (i = 0; i < 48 ; i++ ) {									//  	C̗V臒lŃvbg
			print_Presgraph(i, MemPres[i] );
		}
	}
	print_Presgraph(gX, Value);											//  ݂̋Clvbg
}

//============================================================================
//	Cf[^Plot							
//----------------------------------------------------------------------------
//	́F	Cf[^
//	óF	
//----------------------------------------------------------------------------
//	lF
//
//============================================================================
void	MngplotTemp(int gX, UH Temp)
{
	int i;
	if (Temp & (UH)BIT15) {												//	}CiXwH
		Temp = (~Temp) + 1;												//	ΒlZo
	}
	MemTemp[gX] = Temp/20;												//  Vtgĕ\p̋Cf[^ꎟLB
 
	if (Temp/20 > LCD_MAX_TEMP ) {										//  \̍ől𒴂H
		LCD_MAX_TEMP = Temp/20;											//  ݂̒lőƂ臒lɕύXB
		LCD_MIN_TEMP = LCD_MAX_TEMP - 15 ;
		for (i = 0; i < 48 ; i++ ) {
			print_Tempgraph(i, MemTemp[i] );							//  C̗V臒lŃvbg
		}
	}
	else if (Temp/20 < LCD_MIN_TEMP ) {									//  \̍ŏlH
		LCD_MIN_TEMP = Temp/20;											//  ݂̒lŏƂ臒lɕύXB
		LCD_MAX_TEMP = LCD_MIN_TEMP + 15 ;
		for (i = 0; i < 48 ; i++ ) {
			print_Tempgraph(i, MemTemp[i] );							//  C̗V臒lŃvbg
		}
	}
	print_Tempgraph(gX, (int)Temp/20);									//  Cvbg																	
}

//============================================================================
//	xf[^Plot							
//----------------------------------------------------------------------------
//	́F	xf[^
//	óF	
//----------------------------------------------------------------------------
//	lF
//
//============================================================================
void	MngplotRhum(int gX, UH vRhum)
{
	int i;

	MemRhum[gX] = vRhum/10;												//  Vtgĕ\p̎xf[^ꎟLB
 
	if (vRhum/10 > LCD_MAX_RHUM ) {										//  \̍ől𒴂H
		LCD_MAX_RHUM = vRhum/10;										//  ݂̒lőƂ臒lɕύXB
		LCD_MIN_RHUM = LCD_MAX_RHUM - 31 ;
		for (i = 0; i < 48 ; i++ ) {
			print_Rhumgraph(i, MemRhum[i] );							//  x̗V臒lŃvbg
		}
	}
	else if (vRhum/10 < LCD_MIN_RHUM ) {								//  \̍ŏlH
		LCD_MIN_RHUM = vRhum/10;										//  ݂̒lŏƂ臒lɕύXB
		LCD_MAX_RHUM = LCD_MIN_RHUM + 31 ;
		for (i = 0; i < 48 ; i++ ) {
			print_Rhumgraph(i, MemRhum[i] );							//  x̗V臒lŃvbg
		}
	}
	print_Rhumgraph(gX, vRhum/10);										//  xvbg																	
}

//============================================================================
//	mLA5110LCD֋Cf[^Ot\`悷ׂɃOtԂɕϊB
//----------------------------------------------------------------------------
//	́F	int plotx, int pdata
//	óF	
//----------------------------------------------------------------------------
//	lF	\p
//			VtglύX̍ۂ300hPaȉA1200hpaȏ̃f[^[NullƂăvbgȂB
//============================================================================
void print_Presgraph(int plotx, unsigned short pdata)
{
	int	 pgraphy;

	if (pdata < 1200 && pdata > 300) {									//  300hPaȉA1200hpaȏ̃f[^[NullƂăvbgȂB
		graph_plotx_Presclear(plotx);									//  xʒűCxvbg݂̈̂cɃNAB
		pgraphy = pdata - LCD_MIN_PRES + 32;							//  ^ꂽCl݂̋Cvbg͈͓ɕϊB
		draw_Prespoint(LCD_MAX_X - GRAPH_HIST_MAX + plotx + 1, pgraphy);	//  kbc̃vbgpwʒu߂ĕ\B
	}
}

//============================================================================
//	mLA5110LCD։xf[^Ot\`悷ׂɃOtԂɕϊB
//----------------------------------------------------------------------------
//	́F	int plotx, int tdata
//	óF	
//----------------------------------------------------------------------------
//	lF	\p
//			VtglύX̍ۂ-20ȉA50ȏ̃f[^[NullƂăvbgȂB
//============================================================================
void print_Tempgraph(int plotx, int tdata)
{
	int	 tgraphy;

	if (tdata < 51 && tdata > -20) {									//  -20ȉA50ȏ̃f[^[NullƂăvbgȂB
		graph_plotx_Tempclear(plotx);									//  xʒűCxvbg݂̈̂cɃNAB
		tgraphy = tdata - LCD_MIN_TEMP + 16;							//  ^ꂽCl݂̋Cvbg͈͓ɕϊB
		draw_Temppoint(LCD_MAX_X - GRAPH_HIST_MAX + plotx + 1, tgraphy);	//  kbc̃vbgpwʒu߂ĕ\B
	}
}

//============================================================================
//	mLA5110LCD֎xf[^Ot\`悷ׂɃOtԂɕϊB
//----------------------------------------------------------------------------
//	́F	int plotx, int rhdata
//	óF	
//----------------------------------------------------------------------------
//	lF	\p 2%/dot
//			VtglύX̍ۂ0%A100%ȏ̃f[^[NullƂăvbgȂB
//============================================================================
void print_Rhumgraph(int plotx, int rhdata)
{
	int	 rhgraphy;

	if (rhdata < 101 && rhdata >= 0 ) {									//  0%A100%ȏ̃f[^[NullƂăvbgȂB
		graph_plotx_Rhumclear(plotx);									//  xʒu̎xxvbg݂̈̂cɃNAB
		rhgraphy = (rhdata - LCD_MIN_RHUM)/2;							//  ^ꂽxl݂̎xvbg͈͓ɕϊB
		draw_Rhumpoint(LCD_MAX_X - GRAPH_HIST_MAX + plotx + 1, rhgraphy);	//  kbc̃vbgpwʒu߂ĕ\B
	}
}

//============================================================================
//	mini slash \
//----------------------------------------------------------------------------
//	́F	int col, int bank
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void print_mslash(int col, int bank)
{
	unsigned char *pc;

	LCD_locate(col*4, bank);
	pc = (unsigned char *)font_mslach;
	LCD_set_data(pc, 3);
}

//============================================================================
//	mini colon \
//----------------------------------------------------------------------------
//	́F	int col, int bank
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void print_mcolon(int col,int bank)
{
	unsigned char *pc;

	LCD_locate(col*4, bank);
	pc = (unsigned char *)font_mcolon;
	LCD_set_data(pc, 3);
}

//============================================================================
//	Vtg\pꎞL̈NA
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void shiftmem_clear(void)
{
	int i;
	for (i = 0;i<48;i++) {
		MemPres[i] = 2000;												//  MemPres[]Null̑ɍōlȏŃNAB
		MemTemp[i] = 60;												//  MemTemp[]Null̑ɍōlȏŃNA
		MemRhum[i] = 110;												//  MemTemp[]Null̑ɍōlȏŃNA
	}
}

//============================================================================
//	vOo[WLCDւ̕\
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void	print_version(void){
	int nVer1;
	int nVer2;
	int nVer3;
	int nVer4;

	nVer1 = VER1;
	nVer2 = VER2;
	nVer3 = VER3;
	nVer4 = VER4;

	/* @햼\ */
	print_fonts((char *)"Air3-24GSD",0,1);

	/* uVer.v\ */
	print_fonts((char *)"Ver.",0,3);

	print_num(nVer1,5,3);
	print_num(nVer2,6,3);

	print_fonts((char *)".",7,3);

	print_num(nVer3,8,3);
	print_num(nVer4,9,3);

}

//============================================================================
//	\(F5dotp)
//----------------------------------------------------------------------------
//	́F	char *ptr, int col, int y_bank
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void print_fonts(char *ptr, int col, int y_bank)
{
	int r;
	unsigned char *pc;

	do {
		r = *ptr - 0x20 ;												//  R[h\̈ʒuZo
		LCD_locate(col * 6, y_bank);									//  \ʒuvZ
		pc = (unsigned char *)(FontLookup[r]);							//  R[hAhXZo
		LCD_set_data(pc, 5);											//  iԖ+1̕\
		col++;
		ptr++;
	} while (*ptr);														//  "Null"܂ŌJԂ
}

//============================================================================
//	usecPʃfBC֐
//----------------------------------------------------------------------------
//	́F	PUrbg
//	óF	
//----------------------------------------------------------------------------
//	lF	CLOCK:MIPS of this PIC
//============================================================================
void delay_us(UINT usec)
{
	usec = (UINT)(CLOCK*usec)/ 10;
	while(usec)	{
		asm("NOP");
		asm("NOP");
		asm("NOP");
		asm("NOP");
		asm("NOP");					
		asm("NOP");					
		usec--;
	}
}

//============================================================================
//	msecPʃfBC֐
//----------------------------------------------------------------------------
//	́F	PUrbg
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void delay_ms(UINT msec){
	UINT i;
	for(i=0; i< msec; i++)
		delay_us(1000);
}

// ***************************************************************************
// ***************************************************************************
// *																		 *
// ***************************************************************************
// ***************************************************************************
